<template>
  <div class="box">
    <view-bar>Lokalizacja</view-bar>
    <list-body class="top-list" :status="element_status">
      <h3>{{ name }}</h3>
      <span
        ><tooltip>Rodzaj lokalizacji</tooltip
        ><font-awesome-icon :icon="icons.faHouseUser" /> {{ type }}</span
      >
      <span
        ><tooltip>Adres</tooltip
        ><font-awesome-icon :icon="icons.faMapMarkedAlt" /> {{ street }}</span
      >
      <span
        ><font-awesome-icon
          style="color: transparent"
          :icon="icons.faMapMarkedAlt"
        />
        {{ post_code }} {{ city }}</span
      >
    </list-body>
    <h2>Przedmioty w lokalizacji</h2>
    <list-body :status="list_status" :length="items.length">
      <item-list-item v-for="item in items" :key="item.id" v-bind="item" />
    </list-body>
  </div>
</template>

<script lang="ts">
import { Options, Vue } from "vue-class-component";

import ViewBar from "@/components/ViewBar.vue";
import ListBody from "@/components/list/ListBody.vue";
import ItemListItem from "@/components/list/custom/ItemListItem.vue";

import { LocationData, ItemData } from "@/interfaces";
import GenericEdit from "@/views/edit-views/GenericEdit";
import { NApi, QueryFilter } from "@/interfaces/connector";
import { FontAwesomeIcon } from "@fortawesome/vue-fontawesome";
import Tooltip from "@/components/utilities/Tooltip.vue";
import { faMapMarkedAlt, faHouseUser } from "@fortawesome/free-solid-svg-icons";

@Options({
  props: {
    id: Number,
  },
  components: {
    ViewBar,
    ListBody,
    ItemListItem,
    FontAwesomeIcon,
    Tooltip,
  },
})
export default class EditLocation
  extends GenericEdit<ItemData, LocationData>
  implements LocationData {
  public id!: number;

  public icons = {
    faMapMarkedAlt,
    faHouseUser,
  };

  LIST_API_CALL = async () =>
    await NApi.getItems(
      new QueryFilter().is("location", "location_id", parseInt(String(this.id)))
    );
  ELEMENT_API_CALL = async () =>
    await NApi.getLocation(parseInt(String(this.id)));

  public name = "";
  public type = "";
  public street = "";
  public post_code = "";
  public city = "";

  public items: ItemData[] = [];

  set_list(list: ItemData[]) {
    this.items = list;
  }

  set_element(data: LocationData) {
    this.name = data.name;
    this.type = data.type;
    this.street = data.street;
    this.post_code = data.post_code;
    this.city = data.city;
  }
}
</script>

<style lang="scss" scoped>
@import "@/styles/globals";

.box {
  height: 100%;
  display: grid;

  grid-template-rows: auto auto auto 1fr;

  h3,
  span {
    position: relative;
    display: block;
    padding: 0px;
    margin: 0px;
    text-align: left;

    color: $black_text;
  }

  h3 {
    font-weight: bold;
  }

  .top-list {
    padding-top: 40px;
  }
}
</style>
